/* main */

void input(int argc, char *argv[]);
void define(void);
void obtain(void);


/* define */

void recursiveClusteringFunction(int **configuration, 
				 int length, 
				 int maxorder, 
				 int &NumberConnected);

int findDescriptorIndex(int *descriptor,
			int NumberConnected);

/* bookKeeping */

void findUniqueDescriptorOfCluster(int order,
				   int **configuration,
				   int *descriptor);

void printOutDescriptor(int *descriptor);

void printOutClusterFromDescriptor(int *descriptor);

void printOutCluster(int length, int **configuration);

void symmetryGroup(int switchVariable, 
		   int order,
		   int **configuration,
		   int **tempConfiguration);


void findCartesiansFromGeneralisedPosition(double &x, 
					   double &y, 
					   double &z, 
					   int *configuration);

void findGeneralisedPositionFromCartesians(double &x, 
					   double &y, 
					   double &z, 
					   int *configuration);
void findConfigurationToDescriptor(int *descriptor,
				   int **config,
				   int order); 

int findClusterFromDescriptor(int *descriptor, int **configuration);

void binary(int index, int length, int *spin);
void trimary(int index1, int index2, int index3, int length, int *spin);
void quartary(int index1, int index2, int index3, int length, int *spin);

void obtainDisconnectedClusters(int &NumberDisconnected, 
				int NumberConnected);

void updateDescriptors(int *descriptor,
		       int numberElements);

int subsetClusters(int *descriptor);

void defineGeneralisedPositions();

